- Main Page
- Modules
- Data Structures
- Files
- Related Pages

- Search for |

- Alphabetical List
- Data Structures
- Class Hierarchy
- Data Fields

# UObject Class Reference

UObject is the common ICU "boilerplate" class. More...

`#include <uobject.h>`

Inheritance diagram for UObject:

## Public Member Functions
virtual | ~UObject ()
| Destructor.
virtual UClassID | getDynamicClassID () const=0
| ICU4C "poor man's RTTI", returns a UClassID for the actual ICU class.

## Detailed Description

UObject is the common ICU "boilerplate" class.

UObject inherits UMemory (starting with ICU 2.4), and all other public ICU C++ classes are derived from UObject (starting with ICU 2.2).

UObject contains common virtual functions like for ICU's "poor man's RTTI". It does not contain default implementations of virtual methods like getDynamicClassID to allow derived classes such as Format to declare these as pure virtual.

The clone() function is not available in UObject because it is not implemented by all ICU classes. Many ICU services provide a clone() function for their class trees, defined on the service's C++ base class, and all subclasses within that service class tree return a pointer to the service base class (which itself is a subclass of UObject). This is because some compilers do not support covariant (same-as-this) return types; cast to the appropriate subclass if necessary.

Stable:
  ICU 2.2

Definition at line 184 of file uobject.h.

## Constructor & Destructor Documentation

virtual UObject::~UObject | ( |  | ) | `[virtual]`

Destructor.

Stable:
  ICU 2.2

## Member Function Documentation

virtual UClassID UObject::getDynamicClassID | ( |  | ) | const`[pure virtual]`

ICU4C "poor man's RTTI", returns a UClassID for the actual ICU class.

Stable:
  ICU 2.2

Implemented in BreakIterator, CanonicalIterator, ForwardCharacterIterator, Locale, Normalizer, ParsePosition, RuleBasedBreakIterator, ResourceBundle, StringCharacterIterator, UCharCharacterIterator, UnicodeFilter, UnicodeFunctor, UnicodeSet, UnicodeString, UnicodeSetIterator, Calendar, ChoiceFormat, CollationElementIterator, Collator, CurrencyAmount, CurrencyUnit, DecimalFormatSymbols, DecimalFormat, DateFormatSymbols, DateTimePatternGenerator, DateTimeRule, FieldPosition, Formattable, Format, GregorianCalendar, MessageFormat, NumberFormat, RuleBasedNumberFormat, RuleBasedTimeZone, RegexPattern, RegexMatcher, SimpleTimeZone, SimpleDateFormat, CollationKey, StringSearch, RuleBasedCollator, TimeZone, Transliterator, InitialTimeZoneRule, AnnualTimeZoneRule, TimeArrayTimeZoneRule, TimeZoneTransition, VTimeZone, LEFontInstance, LEGlyphStorage, LayoutEngine, ParagraphLayout::Line, ParagraphLayout::VisualRun, ParagraphLayout, RunArray, FontRuns, LocaleRuns, and ValueRuns.

The documentation for this class was generated from the following file:

- uobject.h